Setting Bing ‘Search Volume History’ Tasks


This endpoint will provide you with historical search volume data for up to 1000 keywords in one request. You can get search volume for keywords in monthly, weekly, or daily format and specify the device type.

This is the Standard method of data retrieval. If you don’t need to receive data in real-time, this method is the best option for you. Set a task and retrieve the results when our system collects them. Execution time depends on the system workload.

If your system requires delivering instant results, the Live method will be a better solution. This method doesn’t require making separate POST and GET requests to the corresponding endpoints.

Historical data is available for two previous years.

checked POST
Pricing

Your account will be charged only for setting a task.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). Task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, with each POST call containing no more than 100 tasks. If your POST call contains over 100 tasks, the tasks over this limit will return the 40006 error. Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

You will get information for every single keyword in an array.

You can send up to 1000 keywords in one keywords array. Our system will charge your account per request, no matter what number of keywords an array has, the price for 1 or 1000 keywords will be the same.

You can also retrieve the results of completed tasks using the unique task identifier id. Alternatively, we can send them to you as soon as they are ready if you specify the postback_url or pingback_url when setting a task. Note that if your server doesn’t respond within 10 seconds, the connection will be aborted by timeout, and the task will be transferred to the tasks_ready list. The error code and message depend on your server’s configuration.

See Help Center to learn more about using pingbacks and postbacks with DataForSEO APIs.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
keywordsarray

keywords
required field
The maximum number of keywords you can specify: 1000
The maximum number of characters for each keyword: 100
the specified keywords will be converted to lowercase, data will be provided in a separate array

learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

location_namestring

full name of search engine location
required field if you don't specify location_code or location_coordinate
if you use this field, you don't need to specify location_code or location_coordinate
you can receive the list of available locations of the search engine with their location_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/locations_and_languages
example:
London,England,United Kingdom

location_codeinteger

search engine location code
required field if you don't specify location_name or location_coordinate
if you use this field, you don't need to specify location_name or location_coordinate
you can receive the list of available locations of the search engines with their location_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/locations_and_languages
example:
2840

location_coordinatestring

GPS coordinates of a location
required field if you don't specify location_name or location_code
if you use this field, you don't need to specify location_name or location_code
location_coordinate parameter should be specified in the "latitude,longitude" format
the data will be provided for the country the specified coordinates belong to
example:
52.6178549,-155.352142

language_namestring
language_codestring
devicearray

device types
optional field
specify this field if you want to get the data for a particular device types
possible values: mobile, desktop, tablet, non_smartphones
default value: ["mobile", "desktop", "tablet", "non_smartphones"]

periodstring

aggregates the returned data to a certain time period
optional field
specify this field if you want to get the data in monthly, weekly or daily format

possible values: monthly, weekly, daily

monthly - returns data up to past 24 months
weekly - returns data up to past 15 weeks
daily - returns data up to past 45 days

default value: monthly

date_fromstring

starting date of the time range
optional field
minimum value: two years back from today’s date
if Status endpoint returns false in the actual_data field, date_from can be set to the month before last and prior;
if Status endpoint returns true in the actual_data field, date_from can be set to the last month and prior;
date format: "yyyy-mm-dd"
example:
"2020-01-01"

Note: we do not recommend using a custom time range

Note 2: if date_from and date_to parameters are not specified, the data will be returned for the past 24 months

if you specify the period parameter:

with value weekly, you will get results for the past 15 weeks
with value daily, you will get results for the past 45 days

date_tostring

ending date of the time range
optional field

minimum value: two years back from today’s date;
maximum value: one day from today's date;
date format: "yyyy-mm-dd"
example:
"2020-03-15"

Note: we do not recommend using a custom time range

Note 2: if date_from and date_to parameters are not specified, the data will be returned for the past 24 months

if you specify the period parameter:

with value weekly, you will get results for the past 15 weeks
with value daily, you will get results for the past 45 days

postback_urlstring

URL for sending task results
optional field
once the task is completed, we will send a POST request with its results compressed in the gzip format to the postback_url you specified
you can use the ‘$id’ string as a $id variable and ‘$tag’ as urlencoded $tag variable. We will set the necessary values before sending the request.
example:
http://your-server.com/postbackscript?id=$id
http://your-server.com/postbackscript?id=$id&tag=$tag
Note: special characters in postback_url will be urlencoded;
i.a., the # character will be encoded into %23

learn more on our Help Center

pingback_urlstring

notification URL of a completed task
optional field
when a task is completed we will notify you by GET request sent to the URL you have specified
you can use the ‘$id’ string as a $id variable and ‘$tag’ as urlencoded $tag variable. We will set the necessary values before sending the request
example:
http://your-server.com/pingscript?id=$id
http://your-server.com/pingscript?id=$id&tag=$tag
Note: special characters in pingback_url will be urlencoded;
i.a., the # character will be encoded into %23

learn more on our Help Center

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

 

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasksarray

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

unique task identifier in our system
unique task identifier in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results
in this case, the value will be null


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/task_post" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "location_code": 2840,
    "language_code": "en",
    "keywords": [
      "10 minute timer"
    ]
  }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
   // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
   $client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
   exit();
}
$post_array = array();
// simple way to set a task
$post_array[] = array(
   "location_name" => "United States",
   "keywords" => array(
      "average page rpm adsense"
   )
);
// after a task is completed, we will send a GET request to the address you specify
// instead of $id and $tag, you will receive actual values that are relevant to this task
$post_array[] = array(
   "language_code" => "en",
   "location_code" => 2840,
   "keywords" => array(
      "adsense blank ads how long"
   ),
   "tag" => "some_string_123",
   "pingback_url" => 'https://your-server.com/pingscript?id=$id&tag=$tag'
);
// after a task is completed, we will send a POST request to the address you specify
// instead of $id and $tag, you will receive actual values that are relevant to this task
$post_array[] = array(
   "location_name" => "United States",
   "language_name" => "English",
   "keywords" => array(
      "leads and prospects"
   ),
   "postback_url" => "https://your-server.com/postbackscript"
);
try {
   // POST /v3/keywords_data/bing/search_volume_history/task_post
   $result = $client->post('/v3/keywords_data/bing/search_volume_history/task_post', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "language_code": "en",
  "location_code": 2840,
  "keywords": ["average page rpm adsense"]
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/task_post',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip

client = RestClient("login", "password")

post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_name="United States",
    keywords=[
        "average page rpm adsense"
    ]
)
# after a task is completed, we will send a GET request to the address you specify
# instead of $id and $tag, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
    language_code="en",
    location_code=2840,
    keywords=[
        "adsense blank ads how long"
    ],
    tag="some_string_123",
    pingback_url="https://your-server.com/pingscript?id=$id&tag=$tag"
)
# after a task is completed, we will send a POST request to the address you specify
# instead of $id and $tag, you will receive actual values that are relevant to this task
post_data[len(post_data)] = dict(
    location_name="United States",
    language_name="English",
    keywords=[        
        "leads and prospects"
    ],
    postback_url="https://your-server.com/postbackscript"
)
# POST /v3/keywords_data/bing/search_volume/task_post
response = client.post("/v3/keywords_data/bing/search_volume_history/task_post", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task keywords_data_task_post()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // simple way to set a task
            postData.Add(new
            {
                location_name = "United States",
                keywords = new[]
                {
                    "average page rpm adsense"
                }
            });
            // after a task is completed, we will send a GET request to the address you specify
            // instead of $id and $tag, you will receive actual values that are relevant to this task
            postData.Add(new
            {
                language_code = "en",
                location_code = 2840,
                keywords = new[]
                {
                    "adsense blank ads how long"
                },
                tag = "some_string_123",
                pingback_url = "https://your-server.com/pingscript?id=$id&tag=$tag"
            });
            // after a task is completed, we will send a GET request to the address you specify
            // instead of $id and $tag you will receive actual values that are relevant to this task
            postData.Add(new
            {
                location_name = "United States",
                language_name = "English",
                keywords = new[]
                {
                    "leads and prospects"
                },
                postback_url = "https://your-server.com/postbackscript"                
            });
            // POST /v3/keywords_data/bing/search_volume_history/task_post
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/bing/search_volume_history/task_post", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20240626",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.0611 sec.",
  "cost": 0.05,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "07101317-1535-0260-0000-5f5e20c3d82e",
      "status_code": 20100,
      "status_message": "Task Created.",
      "time": "0.0019 sec.",
      "cost": 0.05,
      "result_count": 0,
      "path": [
        "v3",
        "keywords_data",
        "bing",
        "search_volume_history",
        "task_post"
      ],
      "data": {
        "api": "keywords_data",
        "function": "search_volume_history",
        "se": "bing",
        "location_code": 2840,
        "language_code": "en",
        "keywords": [
          "10 minute timer"
        ]
      },
      "result": null
    }
  ]
}